﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using System.Collections;

namespace xamDataGrid1
{
    public class GroupByComparer : System.Collections.IComparer
    {
        private bool _ascending;
        private string _fieldName;
        public FieldSortDescription SortDescription { get; set; } 
        public bool UseAdvancedSort { get; set; }

        public GroupByComparer(string fieldName, bool ascending)
        {
            _fieldName = fieldName;
            _ascending = ascending;
        }
        
        #region IComparer Members 
        public int Compare(object x, object y) 
        {
            GroupByRecord groupByRecordX = (GroupByRecord)x;
            GroupByRecord groupByRecordY = (GroupByRecord)y;
            SummaryResultCollection summaryResultCollectionX = groupByRecordX.ChildRecords.SummaryResults;
            SummaryResultCollection summaryResultCollectionY = groupByRecordY.ChildRecords.SummaryResults;
            if (summaryResultCollectionX.Count != 0)
            {
                int result;
                if (_ascending)
                {
                    result = Comparer.Default.Compare(summaryResultCollectionX[_fieldName].Value, summaryResultCollectionY[_fieldName].Value);
                }
                else
                {
                    result = Comparer.Default.Compare(summaryResultCollectionY[_fieldName].Value, summaryResultCollectionX[_fieldName].Value);
                }

                if (result != 0)
                    return result;
            }
            if (_ascending)
            {
                return Comparer.Default.Compare(groupByRecordX.Value, groupByRecordY.Value);
            }
            else
            {
                return Comparer.Default.Compare(groupByRecordY.Value, groupByRecordX.Value);
            }
        }   
        #endregion
    }
}
