﻿using System;
using System.Collections.Generic;
using System.Data;

namespace xamDataGrid1
{
    public class RiskCollection
    {
        public static List<RiskItem> GetRiskCollection()
        {
            var items = new List<RiskItem>();
            var rad = new Random();
            for (int x = 0; x < 40; x++)
            {
                var item = new RiskItem();
                if (x%4 == 0)
                {
                    item.Asset = "MSFT";
                    item.Sector = "Tech";
                }
                else if (x%3 == 0)
                {
                    item.Asset = "SPCSH";
                    item.Sector = "Index";
                }
                else
                {
                    item.Asset = "asset " + x.ToString();
                    item.Sector = "";
                }
                item.Delta = rad.NextDouble()*100;
                item.Gamma = rad.NextDouble()*100;
                item.Theta = rad.NextDouble()*100;
                item.Vol = rad.NextDouble()*10;
                items.Add(item);
            }
            return items;
        }

        public static DataTable GetRiskCollectionAsTable()
        {
            var table = new DataTable();
            table.Columns.Add("Asset");
            table.Columns.Add("Delta", typeof (double));
            table.Columns.Add("Gamma", typeof (double));
            table.Columns.Add("Theta", typeof (double));
            table.Columns.Add("Vol", typeof (double));

            var rad = new Random();
            for (int x = 0; x < 1000; x++)
            {
                string asset;
                if (x%4 == 0)
                    asset = "MSFT";
                else if (x%3 == 0)
                    asset = "SPX";
                else
                {
                    asset = "APPL";
                }
                var delta = rad.NextDouble()*100;
                var gamma = rad.NextDouble()*100;
                var theta = rad.NextDouble()*100;
                var vol = rad.NextDouble()*10;
                var row = new object[5];
                row[0] = asset;
                row[1] = delta;
                row[2] = gamma;
                row[3] = theta;
                row[4] = vol;
                table.Rows.Add(row);
            }
            return table;
        }
    }
}