﻿using System.ComponentModel;

namespace xamDataGrid1
{
    public class RiskItem : INotifyPropertyChanged
    {
        private string asset;
        private double delta;
        private double gamma;
        private string sector;
        private double theta;
        private double vol;

        public double Delta
        {
            get { return delta; }
            set
            {
                delta = value;
                raisePropertyChanged("Delta");
            }
        }

        public double Gamma
        {
            get { return gamma; }
            set
            {
                gamma = value;
                raisePropertyChanged("Gamma");
            }
        }

        public double Theta
        {
            get { return theta; }
            set
            {
                theta = value;
                raisePropertyChanged("Theta");
            }
        }

        public double Vol
        {
            get { return vol; }
            set
            {
                vol = value;
                raisePropertyChanged("Vol");
            }
        }

        public string Asset
        {
            get { return asset; }
            set
            {
                asset = value;
                raisePropertyChanged("Asset");
            }
        }

        public string Sector
        {
            get { return sector; }
            set
            {
                sector = value;
                raisePropertyChanged("Sector");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private void raisePropertyChanged(string propertyName)
        {
            if (PropertyChanged == null)
                return;

            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}